unit SaNumEditDbg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SaNumEdit;

type
  TSaNumEditDbg = class(TSaNumEdit)
  private
    { Private 錾 }
    FLMBox: Boolean;
    FVlBox: Boolean;
    FVTBox: Boolean;
    FRMBox: Boolean;

    procedure SetLMBox(Value: Boolean);
    procedure SetVlBox(Value: Boolean);
    procedure SetVTBox(Value: Boolean);
    procedure SetRMBox(Value: Boolean);
  protected
    { Protected 錾 }
    procedure Paint; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property LMBox: Boolean read FLMBox write SetLMBox default True;
    property VlBox: Boolean read FVlBox write SetVlBox default True;
    property VTBox: Boolean read FVTBox write SetVTBox default True;
    property RMBox: Boolean read FRMBox write SetRMBox default True;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('SaCompo', [TSaNumEditDbg]);
end;

//----------------------------------------------------------------------
(* RXgN^ *)
constructor TSaNumEditDbg.Create(AOwner : TComponent);
begin
  Inherited Create(AOwner);
  FLMBox := True;
  FVlBox := True;
  FVTBox := True;
  FRMBox := True;
end;

//----------------------------------------------------------------------
procedure TSaNumEditDbg.SetLMBox(Value: Boolean);
begin
  if FLMBox <> Value then
  begin
    FLMBox := Value;
    Invalidate;
  end;
end;

procedure TSaNumEditDbg.SetVlBox(Value: Boolean);
begin
  if FVlBox <> Value then
  begin
    FVlBox := Value;
    Invalidate;
  end;
end;

procedure TSaNumEditDbg.SetVTBox(Value: Boolean);
begin
  if FVTBox <> Value then
  begin
    FVTBox := Value;
    Invalidate;
  end;
end;

procedure TSaNumEditDbg.SetRMBox(Value: Boolean);
begin
  if FRMBox <> Value then
  begin
    FRMBox := Value;
    Invalidate;
  end;
end;

//----------------------------------------------------------------------
(* `I[o[Ch *)
procedure TSaNumEditDbg.Paint;
var
  wRect: TRect;
begin
  inherited Paint;

  if FLMBox then
  begin
    wRect := GetLeftMarkRect;
    Canvas.Brush.Color := clBlue;
    Canvas.FrameRect(wRect);
  end;

  if FVlBox then
  begin
    wRect := GetValueRect;
    Canvas.Brush.Color := clPurple;
    Canvas.FrameRect(wRect);
  end;

  if FVTBox then
  begin
    wRect := GetValueTextRect;
    Canvas.Brush.Color := clRed;
    Canvas.FrameRect(wRect);
  end;

  if FRMBox then
  begin
    wRect := GetRightMarkRect;
    Canvas.Brush.Color := clBlue;
    Canvas.FrameRect(wRect);
  end;
end;

end.
