//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ㉺̃ACg@\tTEdit
//  ẼCfg@\ǉ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1210 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, Graphics;

type
  TplVertAlignment = (tvaTop, tvaCenter, tvaBottom);

  TplEdit = class(TEdit)
  private
    FLeftIndent     : Integer;
    FRightIndent    : Integer;
    FVertAlignment  : TplVertAlignment;
    FAlignment      : TAlignment;
    FPermitChars    : TSysCharSet;
    FDefPermitChars : TSysCharSet;
    procedure SetIndentAndVertAlignment;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure SetLeftIndent(const Value: Integer);
    procedure SetRightIndent(const Value: Integer);
    procedure SetVertAlignment(const Value: TplVertAlignment);
    procedure SetAlignment(const Value: TAlignment);
    function GetText: TCaption;
    procedure SetTextBuff(const Value: TCaption);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMFontchanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CreateWnd; override;
    procedure KeyPress(var Key: Char); override;
    procedure WMPaste(var Message: TWMPaste); message WM_PASTE;
  public
    constructor Create(AOwner: TComponent); override;
    property LeftIndent  : Integer     read FLeftIndent  write SetLeftIndent;
    property RightIndent : Integer     read FRightIndent write SetRightIndent;
    property PermitChars : TSysCharSet read FPermitChars write FPermitChars;
  published
    property Text : TCaption read GetText write SetTextBuff;
    property Alignment : TAlignment
      read FAlignment write SetAlignment default taLeftJustify;
    property VertAlignment : TplVertAlignment
      read FVertAlignment write SetVertAlignment default tvaTop;
  end;

procedure Register;

implementation

uses
  Clipbrd;

{ TplEdit }
  
//-----------------------------------------------------------------------------
//  Create
//-----------------------------------------------------------------------------
constructor TplEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FLeftIndent     := 0;
  FRightIndent    := 0;
  FVertAlignment  := tvaTop;
  //$08VK_BACK, $1BVK_ESCAPE
  FDefPermitChars := [#$08, #$1B, ^C, ^V, ^X];

end;

//-----------------------------------------------------------------------------
//  CreateParams
//  EM_SETRECTbZ[W̓}`CłȂƋ@\Ȃ
//  }`CɂĒPs͗pƂ邽߂̐ݒ
//
//  xor ES_WANTRETURN  : EnterL[ł͉sȂ
//                       ꂾ[Alt] + [Enter]ŃXN[Ă܂
//  xor ES_AUTOVSCROLL : cɃXN[Ȃ
//-----------------------------------------------------------------------------
procedure TplEdit.CreateParams(var Params: TCreateParams);
const
  Alignments: array[TAlignment]of Word = (ES_LEFT, ES_RIGHT, ES_CENTER);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or ES_MULTILINE or Alignments[FAlignment];
  Params.Style := Params.Style xor ES_WANTRETURN xor ES_AUTOVSCROLL;
end;

//-----------------------------------------------------------------------------
//  CreateWnd\bh
//  EBhE鎞ɎIɎs郁\bh
//  AlignmentvpeB̒lύXRecreateWnds
//  ̏ȂƏcƍẼCfgꂽ܂܂ɂȂ
//
//  ES_MULTILINEɂ߃pX[hݒ@\ɂȂĂ܂
//  pX[h̐ݒ肪LɂȂ邽߂̑΍R[hǉ
//-----------------------------------------------------------------------------
procedure TplEdit.CreateWnd;
begin
  inherited;
  SetIndentAndVertAlignment;

  if PasswordChar <> #0 then begin
    SendMessage(Handle, EM_SETPASSWORDCHAR, Ord(PasswordChar), 0);
  end;
end;

//-----------------------------------------------------------------------------
//  AlignmentvpeB̐ݒp\bh
//  AlignmentvpeBDelphi 2009ȍ~ł͕W
//-----------------------------------------------------------------------------
procedure TplEdit.SetAlignment(const Value: TAlignment);
begin
  if FAlignment <> Value then begin
    FAlignment := Value;
    RecreateWnd;
  end;
end;

//-----------------------------------------------------------------------------
//  ̃Cfg̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplEdit.SetLeftIndent(const Value: Integer);
begin
  if FLeftIndent <> Value then begin
    FLeftIndent := Value;
    SetIndentAndVertAlignment;
  end;
end;

//-----------------------------------------------------------------------------
//  ẼCfg̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplEdit.SetRightIndent(const Value: Integer);
begin
  if FRightIndent <> Value then begin
    FRightIndent := Value;
    SetIndentAndVertAlignment;
  end;
end;

//-----------------------------------------------------------------------------
//  c̃ACg̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplEdit.SetVertAlignment(const Value: TplVertAlignment);
begin
  if FVertAlignment <> Value then begin
    FVertAlignment := Value;
    RecreateWnd;
  end;
end;

//-----------------------------------------------------------------------------
//  GfBbgRg[(g)EM_SETRECTbZ[W𑗐M鏈
//-----------------------------------------------------------------------------
procedure TplEdit.SetIndentAndVertAlignment;
var
  LRect        : TRect;
  LCellHeight  : Integer;
  LDevieceC    : HDC;
  LCanvas      : TCanvas;
  LTextHeight  : Integer;
  LTopIndent   : Integer;
  L3DDefault   : Integer;
begin
  //GfBbgRg[̃NCAg̈̕ƍ
  LRect       := ClientRect;
  LCellHeight := LRect.Bottom - LRect.Top;

  //foCXReLXgTCanvas𐶐āC̍vZ
  LDevieceC := GetDC(Handle);
  try
    LCanvas := TControlCanvas.Create;
    try
      LCanvas.Handle := LDevieceC;
      LCanvas.Lock;
      LCanvas.Font.Assign(Font);
      LTextHeight := LCanvas.TextHeight('Hg');
    finally
      LCanvas.Unlock;
      FreeAndNil(LCanvas);
    end;
  finally
    ReleaseDC(Handle, LDevieceC);
  end;

  //c̃ACg̐ݒ
  //ۂɂ͕̕`Jn̏[WľvZ
  if Ctl3D then begin
     L3DDefault := 1;
  end else begin
    L3DDefault := 2;
  end;

  LTopIndent := L3DDefault;
  if FVertAlignment = tvaCenter then begin
    LTopIndent := LRect.Top + (LCellHeight - LTextHeight) div 2;
  end else
  if FVertAlignment = tvaBottom then begin
    LTopIndent := LRect.Top + LCellHeight - LTextHeight - L3DDefault;
  end;

  //`̋`̈ݒ
  SetRect(LRect, LRect.Left + FLeftIndent + L3DDefault,
                 LTopIndent,
                 LRect.Right - FRightIndent - L3DDefault,
                 LTopIndent + LTextHeight);
  //gEM_SETRECTbZ[W𑗐M
  SendMessage(Handle, EM_SETRECT, 0, LPARAM(@LRect));
end;

//-----------------------------------------------------------------------------
//  WM_SIZEbZ[W
//  GfBbgRg[̃TCYύXꂽ`̈Đݒ
//-----------------------------------------------------------------------------
procedure TplEdit.WMSize(var Message: TWMSize);
begin
  inherited;
  SetIndentAndVertAlignment;
end;

//-----------------------------------------------------------------------------
//  CM_FONTCHANGEDbZ[W
//  tHgύXꂽ`̈Đݒ
//-----------------------------------------------------------------------------
procedure TplEdit.CMFontchanged(var Message: TMessage);
begin
  inherited;
  SetIndentAndVertAlignment;
end;

//-----------------------------------------------------------------------------
//  ES_MULTILINEɂĂ܂̂ŁC{TEditŎg[Ctrl]+[A]ɂȂ
//  [Ctrl]+[A]Lɂ鏈ǉ
//  TMemoł[Ctrl]+[A]̋@\͎gȂD̃R[hǉΉ\ƂȂ
//
//  ͉̕\ɂ鏈ǉ
//-----------------------------------------------------------------------------
procedure TplEdit.KeyPress(var Key: Char);
var
  IsPermit : Boolean;
begin
  inherited KeyPress(key);

  if key=^A then begin
    SelectAll;
    Key := #$00;
  end else
  if FPermitChars <> [] then begin
    IsPermit := CharInSet(Key, FPermitChars) or CharInSet(Key, FDefPermitChars);
    if not IsPermit then begin
      Key := #$00;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  TextvpeB̎擾p\bh
//-----------------------------------------------------------------------------
function TplEdit.GetText: TCaption;
var
  Len : Integer;
begin
  Len := GetTextLen;
  SetString(Result, PChar(nil), Len);
  if Len <> 0 then begin
    GetTextBuf(PChar(Result), Len + 1);
  end;
end;

//-----------------------------------------------------------------------------
//  TextvpeB̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplEdit.SetTextBuff(const Value: TCaption);
var
  LValue   : String;
  TheText  : String;
  i        : Integer;
begin
  LValue := String(Value);
  if FPermitChars = [] then begin
    TheText := LValue;
  end else begin
    TheText := '';
    for i := 1 to Length(LValue) do begin
      if CharInSet(LValue[i], FPermitChars) then begin
        TheText := TheText + LValue[i];
      end;
    end;
  end;

  Perform(WM_SETTEXT, 0, PChar(TheText));
  Perform(CM_TEXTCHANGED, 0, 0);
end;

//-----------------------------------------------------------------------------
//  WM_PASTEbZ[W
//  [\t]̏
//  PermitCharsݒ肳Ă鎞́CTextvpeBݒp̃\bhgp
//-----------------------------------------------------------------------------
procedure TplEdit.WMPaste(var Message: TWMPaste);
begin
  if FPermitChars = [] then begin
    inherited;
  end else begin
    if Clipboard.HasFormat(CF_TEXT) then begin
      Text := Clipboard.AsText;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('plXRAY', [TplEdit]);
end;

end.

