
//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ㉺̃ACg@\tTMaskEdit
//  ẼCfg@\ǉ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1210 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plMaskEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, Graphics, Mask;

type
  TplMaskVertAlignment = (mtvaTop, mtvaCenter, mtvaBottom);

  TplMaskEdit = class(TMaskEdit)
  private
    FLeftIndent     : Integer;
    FRightIndent    : Integer;
    FAlignment      : TAlignment;
    FVertAlignment  : TplMaskVertAlignment;
    procedure SetIndentAndVertAlignment;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure SetLeftIndent(const Value: Integer);
    procedure SetRightIndent(const Value: Integer);
    procedure SetVertAlignment(const Value: TplMaskVertAlignment);
    procedure SetAlignment(const Value: TAlignment);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMFontchanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CreateWnd; override;
    procedure KeyPress(var Key: Char); override;
  public
    constructor Create(AOwner: TComponent); override;
    property LeftIndent  : Integer read FLeftIndent  write SetLeftIndent;
    property RightIndent : Integer read FRightIndent write SetRightIndent;
  published
    property Alignment : TAlignment
      read FAlignment write SetAlignment default taLeftJustify;
    property VertAlignment : TplMaskVertAlignment
      read FVertAlignment write SetVertAlignment default mtvaTop;
  end;

procedure Register;

implementation

{ TplMaskEdit }

//-----------------------------------------------------------------------------
//  Create
//-----------------------------------------------------------------------------
constructor TplMaskEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FLeftIndent    := 0;
  FRightIndent   := 0;
  FAlignment     := taLeftJustify;
  FVertAlignment := mtvaTop;
end;

//-----------------------------------------------------------------------------
//  CreateParams
//  EM_SETRECTbZ[W̓}`CłȂƋ@\Ȃ
//  }`CɂĒPs͗pƂ邽߂̐ݒ
//
//  xor ES_WANTRETURN  : EnterL[ł͉sȂ
//                       ꂾ[Alt] + [Enter]ŃXN[Ă܂
//  xor ES_AUTOVSCROLL : cɃXN[Ȃ
//-----------------------------------------------------------------------------
procedure TplMaskEdit.CreateParams(var Params: TCreateParams);
const
  Alignments: array[TAlignment]of Word = (ES_LEFT, ES_RIGHT, ES_CENTER);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or ES_MULTILINE or Alignments[FAlignment];;
  Params.Style := Params.Style xor ES_WANTRETURN xor ES_AUTOVSCROLL;
end;

//-----------------------------------------------------------------------------
//  CreateWnd\bh
//  EBhE鎞ɎIɎs郁\bh
//  AlignmentvpeB̒lύXRecreateWnds
//  ̏ȂƏcƍẼCfgꂽ܂܂ɂȂ
//
//  ES_MULTILINEɂ߃pX[hݒ@\ɂȂĂ܂
//  pX[h̐ݒ肪LɂȂ邽߂̑΍R[hǉ
//-----------------------------------------------------------------------------
procedure TplMaskEdit.CreateWnd;
begin
  inherited;
  SetIndentAndVertAlignment;

  if PasswordChar <> #0 then begin
    SendMessage(Handle, EM_SETPASSWORDCHAR, Ord(PasswordChar), 0);
  end;
end;

//-----------------------------------------------------------------------------
//  AlignmentvpeB̐ݒp\bh
//  AlignmentvpeBDelphi 2009ȍ~ł͕W
//-----------------------------------------------------------------------------
procedure TplMaskEdit.SetAlignment(const Value: TAlignment);
begin
  if FAlignment <> Value then begin
    FAlignment := Value;
    RecreateWnd;
  end;
end;

//-----------------------------------------------------------------------------
//  ̃Cfg̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplMaskEdit.SetLeftIndent(const Value: Integer);
begin
  if FLeftIndent <> Value then begin
    FLeftIndent := Value;
    SetIndentAndVertAlignment;
  end;
end;

//-----------------------------------------------------------------------------
//  ẼCfg̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplMaskEdit.SetRightIndent(const Value: Integer);
begin
  if FRightIndent <> Value then begin
    FRightIndent := Value;
    SetIndentAndVertAlignment;
  end;
end;

//-----------------------------------------------------------------------------
//  c̃ACg̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplMaskEdit.SetVertAlignment(const Value: TplMaskVertAlignment);
begin
  if FVertAlignment <> Value then begin
    FVertAlignment := Value;
    RecreateWnd;
  end;
end;

//-----------------------------------------------------------------------------
//  GfBbgRg[(g)EM_SETRECTbZ[W𑗐M鏈
//-----------------------------------------------------------------------------
procedure TplMaskEdit.SetIndentAndVertAlignment;
var
  LRect       : TRect;
  LCellHeight : Integer;
  LDevieceC   : HDC;
  LCanvas     : TCanvas;
  LTextHeight : Integer;
  LTopIndent  : Integer;
  L3DDefault  : Integer;
begin
  //GfBbgRg[̃NCAg̈̕ƍ
  LRect       := ClientRect;
  LCellHeight := LRect.Bottom - LRect.Top;

  //foCXReLXgTCanvas𐶐āC̍vZ
  LDevieceC := GetDC(Handle);
  try
    LCanvas := TControlCanvas.Create;
    try
      LCanvas.Handle := LDevieceC;
      LCanvas.Lock;
      LCanvas.Font.Assign(Font);
      LTextHeight := LCanvas.TextHeight('Hg');
    finally
      LCanvas.Unlock;
      FreeAndNil(LCanvas);
    end;
  finally
    ReleaseDC(Handle, LDevieceC);
  end;

  //c̃ACg̐ݒ
  //ۂɂ͕̕`Jn̏[WľvZ
  if Ctl3D then L3DDefault := 1 else L3DDefault := 2;
  LTopIndent := L3DDefault;
  if FVertAlignment = mtvaCenter then begin
    LTopIndent := LRect.Top + (LCellHeight - LTextHeight) div 2;
  end else
  if FVertAlignment = mtvaBottom then begin
    LTopIndent := LRect.Top + LCellHeight - LTextHeight - L3DDefault;
  end;

  //`̋`̈ݒ
  SetRect(LRect, LRect.Left + FLeftIndent + L3DDefault,
                 LTopIndent,
                 LRect.Right - FRightIndent - L3DDefault,
                 LTopIndent + LTextHeight);

  //gEM_SETRECTbZ[W𑗐M
  SendMessage(Handle, EM_SETRECT, 0, LPARAM(@LRect));
end;

//-----------------------------------------------------------------------------
//  WM_SIZEbZ[W
//  GfBbgRg[̃TCYύXꂽ`̈Đݒ
//-----------------------------------------------------------------------------
procedure TplMaskEdit.WMSize(var Message: TWMSize);
begin
  inherited;
  SetIndentAndVertAlignment;
end;

//-----------------------------------------------------------------------------
//  CM_FONTCHANGEDbZ[W
//  tHgύXꂽ`̈Đݒ
//-----------------------------------------------------------------------------
procedure TplMaskEdit.CMFontchanged(var Message: TMessage);
begin
  inherited;
  SetIndentAndVertAlignment;
end;

//-----------------------------------------------------------------------------
//  ES_MULTILINEɂĂ܂̂ŁC{TEditŎg[Ctrl]+[A]ɂȂ
//  [Ctrl]+[A]Lɂ鏈ǉ
//  EditMastݒ肳Ă鎞́CX[Ctrl]+[A}͖
//-----------------------------------------------------------------------------
procedure TplMaskEdit.KeyPress(var Key: Char);
begin
  inherited KeyPress(key);

  if key=^A then begin
    SelectAll;
    Key := #$00;
  end;
end;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('plXRAY', [TplMaskEdit]);
end;

end.

